/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package example.filesystem;

import org.apache.ws.resource.ResourceContext;
import org.apache.ws.resource.handler.SoapMethodNameMap;
import org.apache.ws.resource.handler.WsrfService;
import org.apache.ws.resource.handler.ServiceSoapMethodNameMap;
import org.apache.ws.resource.lifetime.porttype.ImmediateResourceTerminationPortType;
import org.apache.ws.resource.lifetime.porttype.ScheduledResourceTerminationPortType;
import org.apache.ws.resource.lifetime.porttype.impl.ImmediateResourceTerminationPortTypeImpl;
import org.apache.ws.resource.lifetime.porttype.impl.ScheduledResourceTerminationPortTypeImpl;
import org.apache.ws.resource.properties.porttype.GetMultipleResourcePropertiesPortType;
import org.apache.ws.resource.properties.porttype.GetResourcePropertyPortType;
import org.apache.ws.resource.properties.porttype.QueryResourcePropertiesPortType;
import org.apache.ws.resource.properties.porttype.SetResourcePropertiesPortType;
import org.apache.ws.resource.properties.porttype.impl.GetMultipleResourcePropertiesProvider;
import org.apache.ws.resource.properties.porttype.impl.GetResourcePropertyProvider;
import org.apache.ws.resource.properties.porttype.impl.QueryResourcePropertiesProvider;
import org.apache.ws.resource.properties.porttype.impl.SetResourcePropertiesProvider;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceLifetime12Draft01.DestroyDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceLifetime12Draft01.DestroyResponseDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceLifetime12Draft01.SetTerminationTimeDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceLifetime12Draft01.SetTerminationTimeResponseDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.GetMultipleResourcePropertiesDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.GetMultipleResourcePropertiesResponseDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.GetResourcePropertyDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.GetResourcePropertyResponseDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.QueryResourcePropertiesDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.QueryResourcePropertiesResponseDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.SetResourcePropertiesDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.SetResourcePropertiesResponseDocument;
import javax.xml.namespace.QName;
import java.util.Map;
import java.util.HashMap;

/**
 * This class should be generated on every "generation" against the WSDL.
 * This will ensure it is always up-to-date with the WSDL.
 *
 * NOTE: This class is generated and is NOT meant to be modified.
 *
 * @author Sal Campana, Ian P. Springer
 */
public abstract class AbstractFileSystemService
   implements WsrfService,
              GetResourcePropertyPortType,
              GetMultipleResourcePropertiesPortType,
              SetResourcePropertiesPortType,
              QueryResourcePropertiesPortType,
              ImmediateResourceTerminationPortType,
              ScheduledResourceTerminationPortType
{

   public static final String TARGET_NSURI = "http://ws.apache.org/resource/example/filesystem";
   public static final String TARGET_NSPREFIX = "fs";

   /**
    * DOCUMENT_ME
    */
   private ServiceSoapMethodNameMap m_methodNameMap;

   /**
    * DOCUMENT_ME
    */
   private boolean isInitialized = false;

   /**
    * DOCUMENT_ME
    *
    * @param requestQname DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String getMethodName( QName requestQname )
   {
      if ( !isInitialized )
      {
         init(  );
      }

      return m_methodNameMap.getMethodName( requestQname );
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public abstract ResourceContext getResourceContext(  );

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public final SoapMethodNameMap getMethodNameMap(  )
   {
      return m_methodNameMap;
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public GetMultipleResourcePropertiesResponseDocument getMultipleResourceProperties( GetMultipleResourcePropertiesDocument requestDoc )
   {
      return new GetMultipleResourcePropertiesProvider( getResourceContext(  ) ).getMultipleResourceProperties( requestDoc );
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public SetResourcePropertiesResponseDocument setResourceProperties( SetResourcePropertiesDocument requestDoc )
   {
      return new SetResourcePropertiesProvider( getResourceContext(  ) ).setResourceProperties( requestDoc );
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public GetResourcePropertyResponseDocument getResourceProperty( GetResourcePropertyDocument requestDoc )
   {
      return new GetResourcePropertyProvider( getResourceContext(  ) ).getResourceProperty( requestDoc );
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public SetTerminationTimeResponseDocument setTerminationTime( SetTerminationTimeDocument requestDoc )
   {
      return new ScheduledResourceTerminationPortTypeImpl( getResourceContext(  ) ).setTerminationTime( requestDoc );
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public DestroyResponseDocument destroy( DestroyDocument requestDoc )
   {
      return new ImmediateResourceTerminationPortTypeImpl( getResourceContext(  ) ).destroy( requestDoc );
   }

   /**
    * DOCUMENT_ME
    */
   public void init(  )
   {
      m_methodNameMap    = new ServiceSoapMethodNameMap( getResourceContext(  ) );
      m_methodNameMap.addMapping( new QName( FileSystemService.TARGET_NSURI, "Mount" ),
                                  "mount" );
      m_methodNameMap.addMapping( new QName( FileSystemService.TARGET_NSURI, "Unmount" ),
                                  "unmount"  );
      isInitialized      = true;
   }

   /**
    * DOCUMENT_ME
    *
    * @param requestDoc DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public QueryResourcePropertiesResponseDocument queryResourceProperties( QueryResourcePropertiesDocument requestDoc )
   {
      return new QueryResourcePropertiesProvider( getResourceContext(  ) ).queryResourceProperties( requestDoc );
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   protected final boolean isInitialized(  )
   {
      return isInitialized;
   }
}