/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package example.filesystem;

import javax.xml.namespace.QName;

/**
 * QNames of the resource properties defined by FileSystem WSDL.
 * <p/>
 * NOTE: This class is generated and is NOT meant to be modified.
 *
 * @author Ian P. Springer (Hewlett-Packard Company)
 */
public interface FileSystemPropertyQNames
{

    QName FILESYSTEM_PROPERTIES =
            new QName(FileSystemService.TARGET_NSURI, "FileSystemProperties", FileSystemService.TARGET_NSPREFIX);

    QName DEVICE_SPECIAL_FILE =
            new QName(FileSystemService.TARGET_NSURI, "DeviceSpecialFile", FileSystemService.TARGET_NSPREFIX);

    QName MOUNT_POINT_DIR =
            new QName(FileSystemService.TARGET_NSURI, "MountPointDirectory", FileSystemService.TARGET_NSPREFIX);

    QName TYPE =
            new QName(FileSystemService.TARGET_NSURI, "Type", FileSystemService.TARGET_NSPREFIX);
    QName OPTIONS =
            new QName(FileSystemService.TARGET_NSURI, "Options", FileSystemService.TARGET_NSPREFIX);
    QName BACKUP_FREQUENCY =
            new QName(FileSystemService.TARGET_NSURI, "BackupFrequency", FileSystemService.TARGET_NSPREFIX);
    QName FSCK_PASS_NUMBER =
            new QName(FileSystemService.TARGET_NSURI, "FsckPassNumber", FileSystemService.TARGET_NSPREFIX);
    QName COMMENT =
            new QName(FileSystemService.TARGET_NSURI, "Comment", FileSystemService.TARGET_NSPREFIX);


}
