package example.sysprops;

import org.apache.ws.resource.properties.porttype.QueryResourcePropertiesPortType;
import org.apache.ws.resource.properties.porttype.GetMultipleResourcePropertiesPortType;
import org.apache.ws.resource.properties.porttype.GetResourcePropertyPortType;
import org.apache.ws.resource.properties.porttype.impl.GetResourcePropertyProvider;
import org.apache.ws.resource.properties.porttype.impl.QueryResourcePropertiesProvider;
import org.apache.ws.resource.properties.porttype.impl.GetMultipleResourcePropertiesProvider;
import org.apache.ws.resource.handler.WsrfService;
import org.apache.ws.resource.handler.SoapMethodNameMap;
import org.apache.ws.resource.handler.ServiceSoapMethodNameMap;
import org.apache.ws.resource.ResourceContext;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.GetResourcePropertyResponseDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.GetResourcePropertyDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.GetMultipleResourcePropertiesResponseDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.GetMultipleResourcePropertiesDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.QueryResourcePropertiesResponseDocument;
import org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceProperties12Draft01.QueryResourcePropertiesDocument;


/**
 * @author Sal Campana
 */
public abstract class AbstractJavaSysPropsService  implements WsrfService,
                                                     GetResourcePropertyPortType,
                                                     GetMultipleResourcePropertiesPortType,
                                                     QueryResourcePropertiesPortType
{

    public static final String TARGET_NSURI = "http://ws.apache.org/resource/example/sysprops";
    public static final String TARGET_NSPREFIX = "sp";

       /**
        * DOCUMENT_ME
        */
    private ServiceSoapMethodNameMap m_methodNameMap;

    public SoapMethodNameMap getMethodNameMap()
    {
        return m_methodNameMap;
    }

    public abstract ResourceContext getResourceContext();

    public void init()
    {
        m_methodNameMap = new ServiceSoapMethodNameMap(getResourceContext());
    }

    /**
       * DOCUMENT_ME
       *
       * @param requestDoc DOCUMENT_ME
       *
       * @return DOCUMENT_ME
       */
      public GetMultipleResourcePropertiesResponseDocument getMultipleResourceProperties( GetMultipleResourcePropertiesDocument requestDoc )
      {
         return new GetMultipleResourcePropertiesProvider( getResourceContext(  ) ).getMultipleResourceProperties( requestDoc );
      }


      /**
       * DOCUMENT_ME
       *
       * @param requestDoc DOCUMENT_ME
       *
       * @return DOCUMENT_ME
       */
      public GetResourcePropertyResponseDocument getResourceProperty( GetResourcePropertyDocument requestDoc )
      {
         return new GetResourcePropertyProvider( getResourceContext(  ) ).getResourceProperty( requestDoc );
      }


      /**
       * DOCUMENT_ME
       *
       * @param requestDoc DOCUMENT_ME
       *
       * @return DOCUMENT_ME
       */
      public QueryResourcePropertiesResponseDocument queryResourceProperties( QueryResourcePropertiesDocument requestDoc )
      {
         return new QueryResourcePropertiesProvider( getResourceContext(  ) ).queryResourceProperties( requestDoc );
      }

}
