package example.sysprops;

import org.apache.ws.resource.properties.ResourceProperty;
import org.apache.ws.resource.properties.ResourcePropertyMetaData;
import org.apache.ws.resource.properties.impl.AnyResourcePropertyMetaData;
import org.apache.ws.resource.properties.impl.XmlBeansResourceProperty;
import org.apache.ws.resource.properties.impl.XmlBeansResourcePropertySet;
import org.apache.xmlbeans.XmlException;
import org.apache.xmlbeans.XmlObject;

import javax.xml.namespace.QName;
import java.util.Iterator;
import java.util.Properties;

/**
 * @author Sal Campana
 */
public class JavaSysPropsResource extends AbstractJavaSysPropsResource
{

    private static final String ELEM_NAME_PROPERTY = "property";

    public void init()
    {
        super.init();
        //create a resource metadata and resource property
        ResourcePropertyMetaData propMetaData = new AnyResourcePropertyMetaData( new QName( JavaSysPropsService.TARGET_NSURI, ELEM_NAME_PROPERTY ) );
        ResourceProperty prop = new XmlBeansResourceProperty( propMetaData, (XmlBeansResourcePropertySet) m_propSet );
        //add the property to the prop set
        m_propSet.add( prop );

        //get the current sys properties
        Properties sysProps = System.getProperties();
        Iterator iterator = sysProps.keySet().iterator();
        //iterate the sysprops and add to property set
        while ( iterator.hasNext() )
        {
            String sysPropKey = (String) iterator.next();
            String sysPropValue = sysProps.getProperty( sysPropKey );
            try
            {
                //build an arbitrary XmlObject out of the sysprop data
                XmlObject propElem = XmlObject.Factory.parse( "<" + JavaSysPropsService.TARGET_NSPREFIX + ":" + ELEM_NAME_PROPERTY + " name=\"" + sysPropKey + "\" value=\"" + sysPropValue + "\" xmlns:" + JavaSysPropsService.TARGET_NSPREFIX + "=\"" + JavaSysPropsService.TARGET_NSURI + "\"/>" );
                prop.add( propElem );
            }
            catch ( XmlException e )
            {
                e.printStackTrace();
            }
        }
    }

}
